#ifndef STDIO_H
  #define STDIO_H
  #include <stdio.h>
#endif

#ifndef ASTERISK
	#define ASTERISK -2000
#endif

extern FILE *fp;

#include "lista_nu.h"

l_num Nueva_num()
{
   return((l_num)NULL);
}

l_num insert_num(int dato, l_num list)
{
   l_num tmp, tmp2;

   if(!list && dato == ASTERISK)
   {
	printf("First value cannot be '*'\n");
	exit(1);
   }
   tmp = list;
   if(!(tmp2 = (l_num)malloc(sizeof(struct l_num_st))))
   {
     printf("No memory available\n");
     exit(1);
   }
   tmp2->data = dato;
   tmp2->next = (l_num)NULL;
   if(list)
   {
     while(tmp->next)
       tmp = tmp->next;
     tmp->next = tmp2;
   }
   else
     return(tmp2);
   return(list);
}

l_num free_list_num(l_num list)
{
   l_num tmp;

   while(list)
   {
      tmp = list->next;
      free(list);
      list = tmp;
   } 
   return((l_num)NULL);
}

int num_len(l_num list)
{
  int len;

  len = 0;
  while(list)
  {
    list = list->next;
    len ++;
  }
  return(len);
}

void print_num(l_num list)
{
  while(list)
  {
    if(list->data != ASTERISK)
    {
    	printf("%x ", list->data);
    	fprintf(fp, "%x ", list->data);
    }
    else
    {
	printf("* ");
    	fprintf(fp, "%x ", list->data);
    }
    list = list->next;
  }
}

l_num read_num()
{
   l_num list;
   int num;
   char array[100];

   num = 0;
   list = Nueva_num();
   while(num != -1)
   {
      scanf("%s", array);
      num = read_hex(array);
      if(num != -1)
        list = insert_num(num, list);
   }
   print_num(list);
   return(list);
}

l_num read_ascii()
{
   l_num list;
   int num, i, c;

   num = 0;
   list = Nueva_num();
   do
   {
	c = getchar();
	switch(c)
	{
	 case '*':
   		list = insert_num(ASTERISK, list);
		break;
	 case '\n':
		break;
	 default:
   		list = insert_num(c, list);
	}
   }
   while(c != '\n');
   print_num(list);
   return(list);
}

